net.sf.saxon.tree.iter

## Class SingletonIterator<T extends Item>

- java.lang.Object
- - net.sf.saxon.tree.iter.SingletonIterator<T>

- All Implemented Interfaces:
    LastPositionFinder<T>, SequenceIterator<T>, GroundedIterator<T>, LookaheadIterator<T>, ReversibleIterator<T>, UnfailingIterator<T>

      public class SingletonIterator<T extends Item>
      extends Object
      implements SequenceIterator<T>, UnfailingIterator<T>, ReversibleIterator<T>, LastPositionFinder<T>, GroundedIterator<T>, LookaheadIterator<T>

  SingletonIterator: an iterator over a sequence of zero or one values

- - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.om.SequenceIterator

      `GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the iterator.
    `T` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
    `SingletonIterator<T>` | `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
    `int` | `getLength()` Get the last position (that is, the number of items in the sequence).
    `int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
    `SingletonIterator<T>` | `getReverseIterator()` Get a new SequenceIterator that returns the same items in reverse order.
    `T` | `getValue()`
    `boolean` | `hasNext()` Determine whether there are more items to come.
    `static <T extends Item> UnfailingIterator<T>` | `makeIterator(T item)` Factory method.
    `GroundedValue` | `materialize()` Return a Value containing all the items in the sequence returned by this SequenceIterator
    `T` | `next()` Get the next item in the sequence.
    `int` | `position()` Return the current position in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### makeIterator

          public static <T extends Item> UnfailingIterator<T> makeIterator(T item)

      Factory method.
      Parameters:
        `item` - the item to iterate over
      Returns:
        a SingletonIterator over the supplied item, or an EmptyIterator if the supplied item is null.

    - #### hasNext

          public boolean hasNext()

      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.
      Specified by:
        `hasNext` in interface `LookaheadIterator<T extends Item>`
      Returns:
        true if there are more items

    - #### next

          public T next()

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator, in particular it affects the result of subsequent calls of position() and current().
      Specified by:
        `next` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `next` in interface `UnfailingIterator<T extends Item>`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.

    - #### current

          public T current()

      Description copied from interface: `SequenceIterator`
      Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.
      Specified by:
        `current` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `current` in interface `UnfailingIterator<T extends Item>`
      Returns:
        the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.

    - #### position

          public int position()

      Return the current position in the sequence.
      Specified by:
        `position` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `position` in interface `UnfailingIterator<T extends Item>`
      Returns:
        0 before the first call on next(); 1 before the second call on next(); -1 after the second call on next().

    - #### getLength

          public int getLength()

      Description copied from interface: `LastPositionFinder`
      Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`
      Specified by:
        `getLength` in interface `LastPositionFinder<T extends Item>`
      Returns:
        the number of items in the sequence

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

      Specified by:
        `close` in interface `SequenceIterator<T extends Item>`

    - #### getAnother

          public SingletonIterator<T> getAnother()

      Description copied from interface: `SequenceIterator`
      Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

      This method allows access to all the items in the sequence without disturbing the current position of the iterator. Internally, its main use is in evaluating the last() function.

      This method does not change the state of the iterator.

      Some implementations of this method may regenerate the input sequence, creating new nodes with different identity from the original. This is not recommended, but is hard to prevent. This causes no problem for the primary usage of this method to support the last() function, but it has been known to cause trouble in other situations.

      Specified by:
        `getAnother` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `getAnother` in interface `UnfailingIterator<T extends Item>`
      Returns:
        a SequenceIterator that iterates over the same items, positioned before the first item

    - #### getReverseIterator

          public SingletonIterator<T> getReverseIterator()

      Description copied from interface: `ReversibleIterator`
      Get a new SequenceIterator that returns the same items in reverse order. If this SequenceIterator is an AxisIterator, then the returned SequenceIterator must also be an AxisIterator.
      Specified by:
        `getReverseIterator` in interface `ReversibleIterator<T extends Item>`
      Returns:
        an iterator over the items in reverse order

    - #### getValue

          public T getValue()

    - #### materialize

          public GroundedValue materialize()

      Return a Value containing all the items in the sequence returned by this SequenceIterator
      Specified by:
        `materialize` in interface `GroundedIterator<T extends Item>`
      Returns:
        the corresponding Value. If the value is a closure or a function call package, it will be evaluated and expanded.

    - #### getProperties

          public int getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator<T extends Item>`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.